//full list of elements on this widget
var elements = {};

function resetElements()
{
	//FIXME: optimize it
	for (k in elements)
	{
		if ((k != "root") && (elements[k].widgetParent))
		{
			elements[elements[k].widgetParent].remove(elements[k]);
		}
	};

	for (k in elements)
	{
		if (k != "root") delete elements[k];
	};
}

//register new widget
function alteratorRegisterWidget(id,parent,widget)
{
	elements[id] = widget;
	elements[id].widgetParent = parent;
	elements[(parent=="")?"root":parent].add(widget);
	return widget;
}

//register new button
function alteratorRegisterButton(id,parent)
{
	var button = alteratorRegisterWidget(id,parent,new QxButton);
	//also setup callbacks here
	button.setAttr = function (name,value)
	{
		switch (name)
		{
			case "text":
				this.setText(value);
				break;
			default:
				alert("Unknown attribute " + name + "for button widget");
				break;
		};
	};
	button.setEvent = function (name)
	{
		switch (name)
		{
			case "on-click":
				button.addEventListener("click", function() { emitEvent(id,"on-click",elements); });
				break;
			default:
				alert("Unsupported event-type " + name + "for button widget");
				break;
		};
	};
}

function alteratorRegisterEdit(id,parent)
{
	var edit = alteratorRegisterWidget(id,parent, new QxTextField);
	//also setup callbacks here
	edit.setAttr = function (name,value)
	{
		switch (name)
		{
			case "text":
				this.setText(value);
				break;
			default:
				alert("Unknown attribute " + name + "for button widget");
				break;
		}
	}

	edit.postData = function()
	{
		return " (text . \""+simpleQuote(this.getText())+"\" )";
	}
}

function alteratorRegisterHbox(id,parent)
{
	var hbox = alteratorRegisterWidget(id,parent,new QxHorizontalBoxLayout);
	//also setup callbacks here
}

function alteratorRegisterVbox(id,parent)
{
	var vbox = alteratorRegisterWidget(id,parent,new QxVerticalBoxLayout);
	//also setup callbacks here
}

//processing "new" action request
function alteratorNewRequest(cmd)
{
	var parent = cmd.getAttribute("parent");
	var widgetId = cmd.getAttribute("widget-id");
	var widgetType = cmd.getAttribute("type");

	switch(widgetType)
	{
		case "hbox":
			      alteratorRegisterHbox(widgetId,parent);
			      break;
		case "vbox":
			      alteratorRegisterVbox(widgetId,parent);
			      break;
		case "button":
			      alteratorRegisterButton(widgetId,parent);
			      break;
		case "edit":
			      alteratorRegisterEdit(widgetId,parent);
			      break;
		default:
			      alert("Unknown widget type "+widgetType);
			      break;
	}
}

//processing "set" action request
function alteratorSetRequest(cmd)
{
	var widgetId = cmd.getAttribute("widget-id");
	var name = cmd.getAttribute("attr");
	var value = cmd.getAttribute("value");
	
	elements[widgetId].setAttr(name,value);
}

//processing "add-event" action request
function alteratorCreateEventRequest(cmd)
{
	var widgetId = cmd.getAttribute("widget-id");
	var value = cmd.getAttribute("value");
	elements[widgetId].setEvent(value);
}

//processing "forbidden" action request
function alteratorForbiddenRequest()
{
	alert("Permission denied");
}

//main processor of incoming answers
function alteratorRequestProcessor(answer)
{
	var commands = answer.getElementsByTagName("command");
	var len = commands.length;

	for(var i=0;i<len;++i)
	{
		var elt = commands.item(i);
		var action = elt.getAttribute("action");
		switch (action)
		{
			case "new":
				alteratorNewRequest(elt);
				break;
			case "set":
				alteratorSetRequest(elt);
				break;
			case "create-event":
				alteratorCreateEventRequest(elt);
				break;
			case "forbidden":
				alteratorForbiddenRequest();
				break;
			default:
				alert("Unknown action was received:"+action);
				break;
		}
	}
}

//simple wrapper to get URI
function getURL(url)
{
	alteratorSendRequest("(alterator-request action \"get\" url \""+url+"\")",
			     alteratorRequestProcessor);
}


//simple wrapper to emmiting some events
function emitEvent(widgetId,eventName,elements)
{
	var reqstr = "(alterator-request action \"event\" name \"" + eventName + "\"" +
	             " widget-id \""+widgetId+"\"";
	//collect state data here
	reqstr += " \n state (";
	for (id in elements)
	{
		if (elements[id].postData)
			reqstr += "  \n("+id + elements[id].postData() + ")";
	};
	reqstr += "))";
	alteratorSendRequest(reqstr,alteratorRequestProcessor);
}

function alteratorInit(app)
{
    elements["root"]=app.getClientWindow().getDocument();

    getURL("/");
}
