;helper functions to work with cgi/fastcgi interface
(define-module (alterator http cgi)
	       :use-module (ice-9 rdelim)
	       :use-module (srfi srfi-1)
	       :use-module (srfi srfi-13)
	       :use-module (alterator str)
	       :export (get-cookie
			set-cookie
			
			write-text-xml
			write-text-html
			write-unsupported
			
			get-message
			put-message

			request-method
			remote-address))

(dynamic-call "scm_init_fcgi"
	      (dynamic-link "libguile-fcgi.so"))

(define (fcgi-get-input)
  (do ((result "")
       (line (fcgi-gets) (fcgi-gets)))
    ((not line) result)
    (set! result (string-append result line))))

(define (get-message proc)
  (do ((next-input (fcgi-accept) (fcgi-accept)))
    ((not next-input) 'done)
    (proc (fcgi-get-input))))

(define (request-method)
  (or (getenv "REQUEST_METHOD") "GET"))

(define (remote-address)
  (getenv "REMOTE_ADDR"))

(define (put-message str)
  (fcgi-puts str))

(define (get-cookie)
  (filter
    and
    (map (lambda (x)
	   (let ((attrs (map string-trim-both
			     (string-splitting x #\=))))
	     (and (= (length attrs) 2)
		  (cons (car attrs) (cadr attrs)))))
	 (string-splitting (or (getenv "HTTP_COOKIE") "") #\;))))

(define (set-cookie lst)
  (for-each
    (lambda(x)
      (fcgi-puts (format #f "set-cookie: ~A = ~A" (car x) (cdr x))))
    lst))

(define (newline-str) (string #\newline))

(define (write-text-html)
  (fcgi-puts (string-append "content-type: text/html" (newline-str)(newline-str))))

(define (write-text-xml)
  (fcgi-puts (string-append "content-type: text/xml" (newline-str)(newline-str))))

(define (write-unsupported)
  (write-text-html)
  (fcgi-puts "<html>
	      <body>
	      <p>GET method <b>are not supported</b> for this form</p>
	      </body>
	      </html>"))

