;user's session in http look of alterator
(define-module (alterator http session)
	       :use-module (alterator algo)
	       :export (
			http-session-list
			http-session
			from-session
			make-http-session
			make-session-id

			http-post-event
			http-dump-queue


			make-http-id-generator
			reset-http-id-generator))

(define http-session-list '()) ;alist of sessions

(define http-session (make-fluid))
(fluid-set! http-session '())

(define (from-session name)
  (assq name (fluid-ref http-session)))

(define (make-http-session username)
  `( (http-user . ,username)
     (http-output . (#f))
     (http-id-generator . ,(make-http-id-generator))
     (http-dialogs . ())
     (http-widgets . ())))

(define (make-http-id-generator)
  (let ((counter 0))
    (lambda ()
      (begin-1
	(string-append "w" (number->string counter))
	(set! counter (+ counter 1))))))

(define (reset-http-id-generator)
  (let ((generator (from-session 'http-id-generator)))
    (and generator
	 (set-cdr! generator (make-http-id-generator)))))

(define (http-dump-queue)
  (let ((queue (from-session 'http-output)))
    (and queue
	 (begin-1
	   (cddr queue)
	   (set-cdr! queue (list #f))))))

(define (http-post-event . command)
  (let ((queue (from-session 'http-output)))
    (and queue
	 (append! (cdr queue) (list (cons 'command command))))))

;demo session-id generator
(define random-state (seed->random-state (current-time)))

(define (make-session-id)
  (random 100000000 random-state))

