;description: popup envelop support
;TODO: remove unused use-module
(define-module (alterator lookout popup)
	       :use-module (ice-9 syncase)
	       :use-module (alterator algo)
	       :use-module (alterator command)
	       :use-module (alterator lookout uri)
	       :use-module (alterator lookout context)
	       :use-module (alterator lookout widgets)
	       :export (

			declare-popup-widget
	       		lookout-popup-widget

			with-popup
			make-popup
		
			make-relative-size
			relative-width
			relative-height))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define-syntax with-popup
  (syntax-rules ()
		((_ dlg instruction instructions ...)
		 (with-changed-context 'popup dlg instruction instructions ...))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define lookout-popup-widget #f)

(define-macro (declare-popup-widget func)
	      `(set! lookout-popup-widget ,func))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;create popup envelop over some main widget
(define (make-popup widget-constructor parent main-widget)
  (let ((widget (make-widget widget-constructor))
	(return-value #f))
    (widget 'new parent)
    (with-popup widget
		(widget-parse-args widget (list main-widget))
		(widget 'set-context (fluid-ref lookout-context)))
    (lambda (command . args)
      (case command
	((start)  (set! return-value #f)
		  (widget 'start)
		  return-value)
	((stop)   (widget 'stop)
		  (if (not (null? args))
		    (set! return-value (car args))))
	((delete) (widget 'delete) ((cadr main-widget) 'delete))
	;transfer other events to main widget
	(else (apply (cadr main-widget) command args))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (make-relative-size value name source-widget)
  `(attr ,name
	 ,(quotient (* value (source-widget 'get name))
		    100)))

(define-syntax relative-width
  (syntax-rules()
    ((_ value) (relative-width value (from-context 'goto-frame)))
    ((_ value source-widget)
     (lambda() (make-relative-size value 'width source-widget)))))

(define-syntax relative-height
  (syntax-rules()
    ((_ value) (relative-height value (from-context 'goto-frame)))
    ((_ value source-widget)
     (lambda() (make-relative-size value 'height source-widget)))))

