#include <libguile.h>
#include <fcgi_stdio.h>
#include <string.h>

SCM scm_fcgi_accept(void)
{
	return (FCGI_Accept() >=0 )?SCM_BOOL_T:SCM_BOOL_F;
}

SCM scm_fcgi_puts(SCM str)
{
	SCM_ASSERT(SCM_STRINGP(str), str, SCM_ARG1, "scm_fcgi_puts");

	FCGI_puts(SCM_STRING_CHARS(str));
	return SCM_UNDEFINED;
}


#define MAX_SIZE 1000000*8

//Note: I use limited size strings to prevent DOS atacks in my cgi
SCM scm_fcgi_gets(void)
{
	static char buffer[MAX_SIZE];
	const char *str = FCGI_fgets(buffer,MAX_SIZE - 1, FCGI_stdin);
	return (str  == NULL)?SCM_BOOL_F:scm_mem2string(str,strlen(str));
}

void scm_init_fcgi()
{
	scm_c_define_gsubr("fcgi-accept", 0, 0, 0, (SCM (*)())scm_fcgi_accept);
	scm_c_define_gsubr("fcgi-puts", 1, 0, 0, (SCM (*)())scm_fcgi_puts);
	scm_c_define_gsubr("fcgi-gets", 0, 0, 0, (SCM (*)())scm_fcgi_gets);
}
